codegensawn.compute <-
function(TheTree, variablesavet, maxvalvet, minvalvet, nintervals = 10) {
	ktabs <- function(n) {
		ans <- ""
		for (i in 1:n ) {
			ans <- paste(ans, "\t", sep = "")
		}
		return(ans)
	}
	
	# .scritsawfile <- paste(tempdir(),"\\", "scritsawfile_", round( runif(1)*100000, digits = 0 ), ".R", sep="") # O arquivo de sintaxe do arvoRe
	.scritsawfile <- paste(tempdir(),"\\", "scritsawfile_", 27087, ".R", sep="") # O arquivo de sintaxe do arvoRe
	print(.scritsawfile)
	
	codeline <- "sawn.compute <- \nfunction(...) { \n" ; cat( codeline, file = .scritsawfile, append = FALSE)
	
	indarrayvariablesavet <- 0
	for ( i in variablesavet ) {
		indarrayvariablesavet <- indarrayvariablesavet + 1
		namevari <- i
		sarseqrange <- ( maxvalvet[indarrayvariablesavet] - minvalvet[indarrayvariablesavet] ) / (nintervals - 1)
		codeline <- "\n" ; cat( codeline, file = .scritsawfile, append = TRUE)
		codeline <- paste("sa_", namevari, "_seqrange <- ( ", maxvalvet[indarrayvariablesavet], " - ", minvalvet[indarrayvariablesavet], " ) / (", nintervals, " - 1) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
		codeline <- paste("sa_", namevari, "seqvalues <- seq( ", minvalvet[indarrayvariablesavet], ", ", maxvalvet[indarrayvariablesavet], ", ", sarseqrange, " ) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
		codeline <- paste("labelsvalue_", namevari, " <- array(,0) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	}
	
#	sarseqrange <- ( maxvalvet - minvalvet ) / (nintervals - 1)
#	saseqvalues <- seq(minvalvet, maxvalvet, sarseqrange)
	
	codeline <- "\n" ; cat( codeline, file = .scritsawfile, append = TRUE)
	
	# write the for structure
	ntabs <- ""
	for ( i in variablesavet ) {
		ntabs <- paste(ntabs,"\t", sep = "")
		ntabs2 <- paste(ntabs,"\t", sep = "")
		
		codeline <- paste(ntabs,"for ( index_", i, " in sa_", i, "seqvalues ) {\n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
		codeline <- paste(ntabs2, "# Atualiza o valor da variavel a ser processada na saNw (sensitivity analysis N way) \n", sep = "") ;  cat( codeline, file = .scritsawfile, append = TRUE)
		codeline <- paste(ntabs2, "assign('", i, "', index_", i, " ) \n", sep = "") ;  ; cat( codeline, file = .scritsawfile, append = TRUE)
		codeline <- paste(ntabs2, "assign('", i, "', index_", i, " , envir = .GlobalEnv) \n", sep = "") ;  ; cat( codeline, file = .scritsawfile, append = TRUE)
		codeline <- "\n" ; cat( codeline, file = .scritsawfile, append = TRUE)
	}
	
	codeline <- paste(ntabs2, "\n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, "TheTree <- get('TheTree', envir = .EnvironmentArvoRe) 	\n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, "# Computa os valores das probabilidades que sao string \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, "TheTree$Prob <- sapply(TheTree$Prob,FUN = exec.text) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, "TheTree$Payoff1 <- as.numeric(sapply(TheTree$Payoff1,FUN = exec.text)) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, "TheTree$Payoff2 <- as.numeric(sapply(TheTree$Payoff2,FUN = exec.text)) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, "numrep <- dim(TheTree)[1] \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, "\n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, "\n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	
			
	for ( i in variablesavet ) {
		codeline <- paste(ntabs2, "# Gera a coluna com os valores usados na saNw para a variavel ", i, "\n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
		codeline <- paste(ntabs2, "labelsvalue_", i, " <- c(labelsvalue_", i, ", rep(index_", i, ",numrep)) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	}
			
	codeline <- paste(ntabs2, "\n\n# computa as esperancas com base no valor testado \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, "srspt <- summary.rollback.table(TheTree) \n\n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
			
	codeline <- paste(ntabs2, 'names(srspt) <- c("Level", "Node N", "Node Name", "Expected Cost", "Expected Effectiveness", "Expected C-E Ratio", "Father Node", "Probability",	"Cost", "Effectiveness", "Type") \n\n', sep = '') ; cat( codeline, file = .scritsawfile, append = TRUE)
			
	codeline <- paste(ntabs2, 'if ( exists("ans") ) { \n', sep = '') ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, '	ans <- abind(ans,srspt,along=1) \n', sep = '') ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, '} else { \n', sep = '') ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, '	ans <- srspt	 \n', sep = '') ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste(ntabs2, '} \n', sep = '') ; cat( codeline, file = .scritsawfile, append = TRUE)
	
	
	# close the for structure...
	indarrayvariablesavet <- length(variablesavet) + 1
	for ( i in variablesavet ) {
		indarrayvariablesavet <- indarrayvariablesavet - 1
		ntabs <- ktabs(indarrayvariablesavet)
		codeline <- paste(ntabs,"}\n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	}
	
	codeline <- "\t # add labels \n" ; cat( codeline, file = .scritsawfile, append = TRUE)
	for ( i in variablesavet ) {
		indarrayvariablesavet <- indarrayvariablesavet - 1
		codeline <- paste("\t ans <- data.frame( ", i, " = labelsvalue_", i, ", ans) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	}
	
	codeline <- "\t ans <- as.data.frame(ans) \n" ; cat( codeline, file = .scritsawfile, append = TRUE)
	
	nvariables <- length(variablesavet)
	
	codeline <- paste("\t ans[,4+", nvariables, "] <- as.numeric(as.character( ans[,4+", nvariables, "] )) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste("\t ans[,5+", nvariables, "] <- as.numeric(as.character( ans[,5+", nvariables, "] )) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste("\t ans[,6+", nvariables, "] <- as.numeric(as.character( ans[,6+", nvariables, "] )) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste("\t ans[,8+", nvariables, "] <- as.numeric(as.character( ans[,8+", nvariables, "] )) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste("\t ans[,9+", nvariables, "] <- as.numeric(as.character( ans[,9+", nvariables, "] )) \n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	codeline <- paste("\t ans[,10+", nvariables, "] <- as.numeric(as.character( ans[,10+", nvariables, "] )) \n\n", sep = "") ; cat( codeline, file = .scritsawfile, append = TRUE)
	
	
	codeline <- "\t return(ans) \n" ; cat( codeline, file = .scritsawfile, append = TRUE)
	
	codeline <- "}\n" ; cat( codeline, file = .scritsawfile, append = TRUE)

	return(.scritsawfile)
}
