destinynodewindows <-
function(...) {
	nodeSec <- nodoselecionado()
	if ( .modeltypeArvore != "CE") {
		msg <- paste(" You are not using a Markov model. \n Change the model and try set a node destiny.")
		tkmessageBox(message = msg, icon="warning", title = "ArvoRe - WARNING")
		tkfocus(tt)
	} else {
		if ( nodeSec[1] == " ") {
			msg <- paste("None node selected. Select a tree node and try again.")
			tkmessageBox(message = msg, icon="warning", title = "ArvoRe - WARNING")
			tkfocus(tt)
		} else {
			node.number <- as.numeric(nodeSec[3])
			column <- as.numeric(nodeSec[2])
			position <- intersect(which((TheTree$Level == column)),which(TheTree$Node.N == node.number))
	
			node.type <- TheTree$Type[position]
			
			
			if (node.type == "T") {
				node.Origins <- select.origins(TheTree, node.col = column, node.number = node.number)
				position.exist.markov <- which(node.Origins$Type == "M")
				
				if (length(position.exist.markov) > 0) {
					destinyWindow <- tktoplevel()
					title <- "ArvoRe - Node Destiny"
					tkwm.title(destinyWindow,title)
					
					position.exist.markov <- max(position.exist.markov)
					column.markov <- node.Origins$Level[position.exist.markov]
					number.markov.node <- node.Origins$Node.N[position.exist.markov]
					
					k <- subset(TheTree, Level == column.markov + 1)
					k <- subset(k, Father == number.markov.node)
					k <- k[union( which(k$Type == "C"), which(k$Type == "T")), ]
					
					markov.nodes <- as.character(k$Node.name)
					markov.nodes.position <- as.numeric(k$Node.N)
					markov.nodes.col <- as.numeric(k$Level)
					
					heightlistbox <- length(markov.nodes)
					
					scr <- tkscrollbar(destinyWindow, repeatinterval=5, command=function(...)tkyview(tl,...))
					
					tl <- tklistbox(destinyWindow,height=heightlistbox,selectmode="single",
									yscrollcommand=function(...)tkset(scr,...),background="white")
					tkgrid(tklabel(destinyWindow,text="Select a destiny node"))
					tkgrid(tl,scr)
					tkgrid.configure(scr,rowspan=4,sticky="nsw")
					
					for (i in (1:heightlistbox)) {
					    tkinsert(tl,"end",markov.nodes[i])
					}
					
					if ( (TheTree$Destiny[position[1]] != " ") && 
							(TheTree$Destiny[position[1]] != "") && 
							(nchar(TheTree$Destiny[position[1]]) > 0)
						){
						selected <- which( markov.nodes.position == as.numeric(TheTree$Destiny[position[1]]))
						tkselection.set(tl,selected-1)
					}
					
					OnOK <- function()
					{

						valueselection <- as.numeric(tkcurselection(tl))+1
						
						commandstringformat <- paste("destinyChoice <- markov.nodes.position[",valueselection,"]", sep="")
						add.Syntax(commandstringformat)
						
						destinyChoice <- markov.nodes.position[valueselection]
						
						safedofunction(TheTree, .EnvironmentArvoRe, .modeltypeArvore)
						
						commandstringformat <- paste("TheTree$Destiny[",position,"] <- destinyChoice", sep="")
						add.Syntax(commandstringformat)
						TheTree$Destiny[position] <- destinyChoice
						
						commandstringformat <- paste("setdestinynode(TheTree, .EnvironmentArvoRe)", sep="")
						add.Syntax(commandstringformat)
						setdestinynode(TheTree, .EnvironmentArvoRe)
						
						
						tkdestroy(destinyWindow)
						tkfocus(tt)
					}
					
					OnCancel <- function()
					{
						tkdestroy(destinyWindow)
						tkfocus(tt)
					}
					
					OK.but <-tkbutton(destinyWindow,text="   OK     ",command=OnOK)
					tkbind(destinyWindow, "<Return>",OnOK)
					Cancel.but <-tkbutton(destinyWindow,text=" Cancel ",command=OnCancel)
					tkbind(destinyWindow, "<Escape>",OnCancel)
			
					tkgrid(OK.but, Cancel.but, sticky = "s", padx = 5, pady = 5)
					
					posiciona.janela.no.mouse(destinyWindow, 230, 150)
					
					tkfocus(destinyWindow)
				} else {
					msg <- paste("The selected node is not a transition node from one node type 'Markov'. \n Only transition nodes follow a destiny.")
					tkmessageBox(message = msg, icon="warning", title = "ArvoRe - WARNING")
					tkfocus(tt)
				}
			} else {
				msg <- paste("The selected node is not a 'Terminal' node. \n Only terminal nodes have a destiny.")
				tkmessageBox(message = msg, icon="warning", title = "ArvoRe - WARNING")
				tkfocus(tt)
			}
			
		}
	}
}
