dialog.formulaeditor.markov.window <-
function(TheTree, markov.propertiesMAT, valuetype, adrtclvar) {
	nodeSec <- nodoselecionado()
	if ( nodeSec[1] == " ") {
		msg <- paste("None selected node. Select a tree node and try again.")
		tkmessageBox(message = msg, icon="warning", title = "ArvoRe - WARNING")
		tkfocus(tt)
	} else {
		node.number <- as.numeric(nodeSec[3])
		column <- as.numeric(nodeSec[2])
		position <- intersect(which((TheTree$Level == column)),which(TheTree$Node.N == node.number))
		node.type <- TheTree$Type[position]
		node.name <- TheTree$Node.name[position]
		
		setvalueWindow <- tktoplevel()
		title <- "ArvoRe - Formula Editor"
		tkwm.title(setvalueWindow,title)
		
		# Create frames
		FrameOverall <- tkframe(setvalueWindow, borderwidth = 0, relief = "groove")
		FrameLeft <- tkframe(FrameOverall, borderwidth = 0, relief = "groove")
		FrameRight <- tkframe(FrameOverall, borderwidth = 0, relief = "groove")
		FrameButton <- tkframe(FrameRight, borderwidth = 2, relief = "groove")
		FrameMenuButton <- tkframe(FrameLeft, borderwidth = 2, relief = "groove")
		FrameLower <- tkframe(FrameOverall, borderwidth = 0, relief = "groove")
		
		# Node label
		text.to.label <- paste("Node : ", node.name, sep = "")
		node.tk.label <- tklabel(FrameLeft, text = text.to.label)
		if (node.type == "C") node.type.label <- "Chance"
		else if (node.type == "T") node.type.label <- "Terminal"
		else if (node.type == "M") node.type.label <- "Markov"
		else if (node.type == "D") node.type.label <- "Decision"
		else node.type.label <- "Unknow"
		
		text.to.label <- paste("Type : ", node.type.label, sep = "")
		node.tk.type <- tklabel(FrameLeft, text = text.to.label)
		
		tkgrid(node.tk.label, sticky = "nw", columnspan = 2)
		tkgrid(node.tk.type, sticky = "nw", columnspan = 2)
		
		# The menubutton width
		menubutton.width <- 15
		
######### O menubutton
		Operators <- tkmenubutton(FrameMenuButton, text = "Operators", direction = "below", 
							borderwidth = 1, relief = "raised", indicatoron = TRUE,
							width = menubutton.width)	
######### O menu associado ao menubutton
		menuOperatorsChild <- tkmenu(Operators, tearoff=FALSE)
			# Os tens do tem "Boto de menu"
			tkadd(menuOperatorsChild,"command",label=">",command=function() { tkinsert(Text.space,"end",">") })
			tkadd(menuOperatorsChild,"command",label="<",command=function() { tkinsert(Text.space,"end","<") })
			tkadd(menuOperatorsChild,"command",label=">=",command=function() { tkinsert(Text.space,"end",">=") })
			tkadd(menuOperatorsChild,"command",label="<=",command=function() { tkinsert(Text.space,"end","<=") })
			tkadd(menuOperatorsChild,"command",label="==",command=function() { tkinsert(Text.space,"end","==") })
			tkadd(menuOperatorsChild,"command",label="!=",command=function() { tkinsert(Text.space,"end","!=") })
			tkadd(menuOperatorsChild,"separator")
			tkadd(menuOperatorsChild,"command",label="&&",command=function() { tkinsert(Text.space,"end","&&") })
			tkadd(menuOperatorsChild,"command",label="||",command=function() { tkinsert(Text.space,"end","||") })
			tkadd(menuOperatorsChild,"separator")
			tkadd(menuOperatorsChild,"command",label="(",command=function() { tkinsert(Text.space,"end","(") })
			tkadd(menuOperatorsChild,"command",label=")",command=function() { tkinsert(Text.space,"end",")") })			
			tkadd(menuOperatorsChild,"separator")
			tkadd(menuOperatorsChild,"command",label="+",command=function() { tkinsert(Text.space,"end","+") })
			tkadd(menuOperatorsChild,"command",label="-",command=function() { tkinsert(Text.space,"end","-") })
			tkadd(menuOperatorsChild,"command",label="*",command=function() { tkinsert(Text.space,"end","*") })
			tkadd(menuOperatorsChild,"command",label="/",command=function() { tkinsert(Text.space,"end","/") })
			tkadd(menuOperatorsChild,"command",label="^",command=function() { tkinsert(Text.space,"end","^") })
			tkadd(menuOperatorsChild,"separator")
			tkadd(menuOperatorsChild,"separator")
			tkadd(menuOperatorsChild,"command",label="Sair",command=function() tkdestroy(setvalueWindow))
		# Ajusta que o menu associado ao menubutton  menufilho
		tkconfigure(Operators, menu = menuOperatorsChild)
		# Monta o rtulo e o checkbutton
		
		
######### O menubutton
		Functions <- tkmenubutton(FrameMenuButton, text = "Functions", direction = "below", 
							borderwidth = 1, relief = "raised", indicatoron = TRUE,
							width = menubutton.width)
######### O menu associado ao menubutton
		menuFunctionsChild <- tkmenu(Functions, tearoff = FALSE)
			# Os tens do tem "Boto de menu"
			tkadd(menuFunctionsChild,"command",label="exp",command=function() { tkinsert(Text.space,"end","exp(") })
			tkadd(menuFunctionsChild,"command",label="ln",command=function() { tkinsert(Text.space,"end","log(") })
			tkadd(menuFunctionsChild,"command",label="log10",command=function() { tkinsert(Text.space,"end","log10(") })
			tkadd(menuFunctionsChild,"command",label="sqrt",command=function() { tkinsert(Text.space,"end","sqrt(") })
			tkadd(menuFunctionsChild,"command",label="power",command=function() { tkinsert(Text.space,"end","^") })
			tkadd(menuFunctionsChild,"command",label="gamma function",command=function() { tkinsert(Text.space,"end","gamma(") })
			tkadd(menuFunctionsChild,"separator")
			tkadd(menuFunctionsChild,"command",label="min",command=function() { tkinsert(Text.space,"end","min(") })
			tkadd(menuFunctionsChild,"command",label="max",command=function() { tkinsert(Text.space,"end","max(") })
			tkadd(menuFunctionsChild,"command",label="mean",command=function() { tkinsert(Text.space,"end","mean(") })
			tkadd(menuFunctionsChild,"command",label="stdev",command=function() { tkinsert(Text.space,"end","stdev(") })
			tkadd(menuFunctionsChild,"command",label="sum",command=function() { tkinsert(Text.space,"end","sum(") })
			tkadd(menuFunctionsChild,"command",label="prod",command=function() { tkinsert(Text.space,"end","prod(") })
			tkadd(menuFunctionsChild,"separator")
			tkadd(menuFunctionsChild,"command",label="abs",command=function() { tkinsert(Text.space,"end","abs(") })
			tkadd(menuFunctionsChild,"command",label="int",command=function() { tkinsert(Text.space,"end","int(") })
			tkadd(menuFunctionsChild,"command",label="round",command=function() { tkinsert(Text.space,"end","round(") })
			tkadd(menuFunctionsChild,"command",label="floor",command=function() { tkinsert(Text.space,"end","floor(") })
			tkadd(menuFunctionsChild,"command",label="ceiling",command=function() { tkinsert(Text.space,"end","ceiling(") })
			tkadd(menuFunctionsChild,"command",label="modulo",command=function() { tkinsert(Text.space,"end","modulo(") })
			tkadd(menuFunctionsChild,"separator")
			tkadd(menuFunctionsChild,"command",label="prob2odds",command=function() { tkinsert(Text.space,"end","prob2odds(") })
			tkadd(menuFunctionsChild,"command",label="odds2prob",command=function() { tkinsert(Text.space,"end","odds2prob(") })
			tkadd(menuFunctionsChild,"command",label="factorial",command=function() { tkinsert(Text.space,"end","factorial(") })
		# Ajusta que o menu associado ao menubutton  menufilho
		tkconfigure(Functions, menu = menuFunctionsChild)
		
######### O menubutton
		Keywords <- tkmenubutton(FrameMenuButton, text = "Keyword", direction = "below", 
							borderwidth = 1, relief = "raised", indicatoron = TRUE,
							width = menubutton.width)
######### O menu associado ao menubutton
		menuKeywordsChild <- tkmenu(Keywords, tearoff = FALSE)
			# Os tens do tem "Boto de menu"
			tkadd(menuKeywordsChild,"command",label=".stage",command=function() { tkinsert(Text.space,"end",".stage") })
			tkadd(menuKeywordsChild,"command",label=".stage.cost",command=function() { tkinsert(Text.space,"end",".stage.cost") })
			tkadd(menuKeywordsChild,"command",label=".stage.eff",command=function() { tkinsert(Text.space,"end",".stage.eff") })
			tkadd(menuKeywordsChild,"command",label=".stage.reward",command=function() { tkinsert(Text.space,"end",".stage.reward") })
			tkadd(menuKeywordsChild,"separator")
			tkadd(menuKeywordsChild,"command",label=".total.cost",command=function() { tkinsert(Text.space,"end",".total.cost") })
			tkadd(menuKeywordsChild,"command",label=".total.eff",command=function() { tkinsert(Text.space,"end",".total.eff") })
			tkadd(menuKeywordsChild,"command",label=".total.reward",command=function() { tkinsert(Text.space,"end",".total.reward") })
			tkadd(menuKeywordsChild,"command",label="NONE",command=function() { tkinsert(Text.space,"end","NONE") })
		# Ajusta que o menu associado ao menubutton  menufilho
		tkconfigure(Keywords, menu = menuKeywordsChild)

######### O menubutton
		Variables <- tkmenubutton(FrameMenuButton, text = "Variables", direction = "below", 
							borderwidth = 1, relief = "raised", indicatoron = TRUE,
							width = menubutton.width)
######### O menu associado ao menubutton
		menuVariablesChild <- tkmenu(Variables, tearoff = FALSE)
			if ( length(variableMAT$Name) > 0 ) {
				for ( elemento in variableMAT$Name ) {
					comandoaexecutar <- paste( 'tkadd(menuVariablesChild,"command",label="', elemento, '",command=function() { tkinsert(Text.space,"end","', elemento, '") })', sep = '')
					eval(parse(text=comandoaexecutar))
				}
			} else {
				tkadd(menuVariablesChild,"command",label="empty",command=function() { } )
				tkadd(menuVariablesChild,"separator")
			}

		# Ajusta que o menu associado ao menubutton  menufilho
		tkconfigure(Variables, menu = menuVariablesChild)		
		
######### O menubutton
		Distributions <- tkmenubutton(FrameMenuButton, text = "Distributions", direction = "below", 
							borderwidth = 1, relief = "raised", indicatoron = TRUE,
							width = menubutton.width)
######### O menu associado ao menubutton
		menuDistributionsChild <- tkmenu(Distributions, tearoff = FALSE)
			if (!exists("distributionMAT",.EnvironmentArvoRe)) {
				new.distribution.list() # se no existe uma tabela de variaveis, ento ele cria.
				#assign("distributionMAT", ans, envir = .EnvironmentArvoRe)
			}
			if ( length(distributionMAT$Name) > 0 ) {
				for ( elemento in distributionMAT$Name ) {
					comandoaexecutar <- paste( 'tkadd(menuDistributionsChild,"command",label="', elemento, '",command=function() { tkinsert(Text.space,"end","', elemento, '") })', sep = '')
					eval(parse(text=comandoaexecutar))
				}
			} else {
				tkadd(menuDistributionsChild,"command",label="empty",command=function() { } )
				tkadd(menuDistributionsChild,"separator")
			}

		# Ajusta que o menu associado ao menubutton  menufilho
		tkconfigure(Distributions, menu = menuDistributionsChild)
		
		
######### O menubutton
		Financial <- tkmenubutton(FrameMenuButton, text = "Financial", direction = "below", 
							borderwidth = 1, relief = "raised", indicatoron = TRUE,
							width = menubutton.width)
######### O menu associado ao menubutton
		menuFinancialChild <- tkmenu(Financial, tearoff = FALSE)
			# Os tens do tem "Boto de menu"
			tkadd(menuFinancialChild,"command",label="Discount",command=function() { tkinsert(Text.space,"end","discount_tx(monetary_value, rate, time)") })
			tkadd(menuFinancialChild,"command",label="NONE",command=function() { tkinsert(Text.space,"end","NONE") })
		# Ajusta que o menu associado ao menubutton  menufilho
		tkconfigure(Financial, menu = menuFinancialChild)
		
		# Monta os menubuttons
		tkgrid(Operators, Functions, Keywords, Variables, sticky = "n", padx = 5, pady = 5)
		tkgrid(Variables, Distributions, Financial, sticky = "n", padx = 5, pady = 5)

		# O campo de texto para entrada da expression.
		Text.space <- tktext(FrameLeft, borderwidth = 2, relief = "sunken",
								height = 5, width = 30, wrap = "word")
		tkinsert(Text.space,"end", tclvalue(adrtclvar) ) }
		
		
		OnOK <- function()
		{
			# .t get 1.0 end
			z <- tclvalue( tkget( Text.space, "1.0", "end -1 chars") )
			.flg <- is.numeric( exec.text(z) )
			if ( ! .flg ) {
				msg <- paste("The input expression is not valid. Please check the expression and try again.")
				tkmessageBox(message = msg, icon="error", title = "ArvoRe - ERROR")
				tkfocus(setvalueWindow)
			} else {
				# aplica a expresso  tree
				if ( valuetype == "Value" ) {
					assign(".formulaeditorvalue.Value", z, envir = .EnvironmentArvoRe)
					tcl("set",adrtclvar,z)
				}
				if ( valuetype == "Value2" ) {
					assign(".formulaeditorvalue.Value2", z, envir = .EnvironmentArvoRe)
					tcl("set",adrtclvar,z)
				}
				if ( valuetype == "Value3" ) {
					assign(".formulaeditorvalue.Value3", z, envir = .EnvironmentArvoRe)
					tcl("set",adrtclvar,z)
				}
				if ( valuetype == "Value4" ) {
					assign(".formulaeditorvalue.Value4", z, envir = .EnvironmentArvoRe)
					tcl("set",adrtclvar,z)
				}
				if ( valuetype == "Value5" ) {
					assign(".formulaeditorvalue.Value5", z, envir = .EnvironmentArvoRe)
					tcl("set",adrtclvar,z)
				}
				if ( valuetype == "Value6" ) {
					assign(".formulaeditorvalue.Value6", z, envir = .EnvironmentArvoRe)
					tcl("set",adrtclvar,z)
				}
				
				tkdestroy(setvalueWindow)
			#	tkfocus(tt)	
			}
		}
		
		OnCancel <- function()
		{
			tkdestroy(setvalueWindow)
			tkfocus(tt)
		}
		
    	.Width.but <- 10
		.Height.but <- 1
		
		OK.but <-tkbutton(FrameLower,text="OK", width=.Width.but, height=.Height.but, command=OnOK)
		Cancel.but <-tkbutton(FrameLower,text="Cancel", width=.Width.but, height=.Height.but, command=OnCancel)
		
		tkbind(setvalueWindow, "<Escape>",OnCancel)
		
		tkgrid(OK.but, Cancel.but, sticky = "s", padx = 5, pady = 5)
		
		tkgrid(FrameButton, sticky = "nwe")
		tkgrid(FrameMenuButton, sticky = "nwe")
		tkgrid(Text.space, sticky = "swe", padx = 5, pady = 5)
		tkgrid(FrameLeft, FrameRight, sticky = "nwe")
		tkgrid(FrameLower, sticky = "swe")
		tkgrid(FrameOverall)
		
		tkfocus(setvalueWindow)
	}
