markov.coort.ctrl.table <-
function(TheTree, markov.propertiesMAT, markov.termination, initial.coort = 10000, seed = FALSE,
								absorventstatedeath = 1) {

	# Gera os valores das distribuies
	if ( exists("distributionMAT", envir = .EnvironmentArvoRe) ) {
		distributionMAT <- get("distributionMAT", envir = .EnvironmentArvoRe)
		
		ndistributionMAT <- dim(distributionMAT)[1]
		distributionMAT.Names <- as.character(distributionMAT[,1])
		distributionMAT.Distribution <- as.character(distributionMAT[,3])
		distributionMAT.Parameters <- as.character(distributionMAT[,4])
		
		for ( i in 1:ndistributionMAT ) {
			commandoprocessar <- paste("assign('.distribution.Values.",distributionMAT.Names[i],"', r", distributionMAT.Distribution[i], "(initial.coort, ", distributionMAT.Parameters[i], ") )", sep = "")
			eval(parse(text=commandoprocessar))
			commandoprocessar <- paste(".distribution.Values.",distributionMAT.Names[i]," <- r", distributionMAT.Distribution[i], "(initial.coort, ", distributionMAT.Parameters[i], ")", sep = "")
			eval(parse(text=commandoprocessar))		
		}
	} else {
		return()
	}
	
	# gera semente para cada trial, controle
	# ajusta a semente escolhida pelo usurio
	if (seed != FALSE) {
		set.seed(seed)	
#		.arvSeedVal <- runif(initial.coort, 0, 1)
	}
	
	# funo para o parse das expresses
	parse.distribution.expression <-
	function(exprdistr.arvore) {
		if ( exists("distributionMAT", envir = .EnvironmentArvoRe) ) {
			distributionMAT <- get("distributionMAT", envir = .EnvironmentArvoRe)
			if ( length(distributionMAT[,1]) >= 1 ) {
				nexprdistr.arvore <- length(exprdistr.arvore)
				ndistributionMAT <- dim(distributionMAT)[1]
				distributionMAT.Names <- as.character(distributionMAT[,1])
				distributionMAT.Distribution <- as.character(distributionMAT[,3])
				distributionMAT.Parameters <- as.character(distributionMAT[,4])
				
				for ( i in 1:ndistributionMAT ) {
					commandoprocessar <- paste(".distribution.Values.",distributionMAT.Names[i],"[", trialnumber,"]", sep = "")
					.distribution.valordtr <- eval(parse(text=commandoprocessar))
					if ( sum(str_detect(exprdistr.arvore, distributionMAT.Names[i])) > 0 ) { 
							distributionMAT.valornovo <- .distribution.valordtr
							commandoprocessar <- str_replace_all(exprdistr.arvore, distributionMAT.Names[i], distributionMAT.valornovo)
							# distributionMAT.ans[j] <- eval(parse(text=commandoprocessar)) # no vamos retornar o valor...
							exprdistr.arvore <- commandoprocessar
						}
				}
			}
		} 
		return(exprdistr.arvore)
	}

	# Cria listas para comportar os objetos
	# .arv.Cost.sim <- list()
	# .arv.Effec.sim <- list()
	# .arv.SurvivalCurve.sim <- list()
	# .arv.Path.sim <- list()
	
	# for (trialnumber in 1:initial.coort ) {
		# .arv.Cost.sim[[trialnumber]] <- NaN 
	# }
	# .arv.Effec.sim <- .arv.Cost.sim
	# .arv.SurvivalCurve.sim <- .arv.Cost.sim
	# .arv.Path.sim <- .arv.Cost.sim
	
	# Restore tcl values for GUI
	arvsimulationstopflag <- get("arvsimulationstopflag", envir = .EnvironmentArvoRe)
	arvsimtrialnumber <- get("arvsimtrialnumber", envir = .EnvironmentArvoRe)

	# realiza a simulao de cada sujeito na coorte
	for (trialnumber in 1:initial.coort ) {
		stopifnot( tclvalue(arvsimulationstopflag) == 0) # variable used to stop simulation
		#tkset(arvsimtrialnumber, trialnumber) # Update the GUI about simulation
		tcl("set", arvsimtrialnumber, trialnumber)
		tcl("update")
		
		# cat("Mostrando a arvore original : \n")
		# print(TheTree)
		
		# Realiza o parser da rvore
		.stnarvTheTree <- TheTree
		.stnarvTheTree$Prob <- parse.variable.expression.tree(TheTree$Prob)
		.stnarvTheTree$Payoff1 <- parse.variable.expression.tree(TheTree$Payoff1)
		.stnarvTheTree$Payoff2 <- parse.variable.expression.tree(TheTree$Payoff2)
		
		# cat("Fazendo parser das distribuies \n")
		.stnarvTheTree$Prob <- parse.distribution.expression.tree(.stnarvTheTree$Prob)
		.stnarvTheTree$Payoff1 <- parse.distribution.expression.tree(.stnarvTheTree$Payoff1)
		.stnarvTheTree$Payoff2 <- parse.distribution.expression.tree(.stnarvTheTree$Payoff2)

		.stnarvTheTree$Prob <- parse2.one.numeric.expression.tree(.stnarvTheTree$Prob)
		.stnarvTheTree$Payoff1 <- parse2.one.numeric.expression.tree(.stnarvTheTree$Payoff1)
		.stnarvTheTree$Payoff2 <- parse2.one.numeric.expression.tree(.stnarvTheTree$Payoff2)
		
		# Seleciona a semente para a simulao
		# if (seed != FALSE) {
			# .seedValuetrial = .arvSeedVal[trialnumber]
		# } else {
			# .seedValuetrial = FALSE
		# }

		# cat("Mostrando a arvore convertida : \n")
		# print(.stnarvTheTree)
	
		# Mktable <- markov.coort.table(TheTree, markov.propertiesMAT, markov.termination = markov.termination, 
										# initial.coort = 1, seed = .seedValuetrial, absorventstatedeath = absorventstatedeath)
		# --------------------------------------- END Seed control 
		Mktable <- markov.coort.table(.stnarvTheTree, markov.propertiesMAT, markov.termination = markov.termination, 
										initial.coort = 1, absorventstatedeath = absorventstatedeath)
										
		# Mostra a trajetria do sujeito...		
		# cat(paste("##### SUJEITO ",trialnumber, " da coorte \n", sep = ""))
		# print(Mktable)
		
		if ( trialnumber != 1 ) {
			.arv.Cost.sim <- as.matrix(cbind(.arv.Cost.sim, as.matrix(Mktable$Cost) ) )
			.arv.Effectiveness.sim <- as.matrix( cbind(.arv.Effectiveness.sim, as.matrix(Mktable$Effectiveness) ) )
			.arv.Survival.sim <- as.matrix( cbind(.arv.Survival.sim, as.matrix( Mktable$Survival) ) )
			.arv.Path.sim <- as.matrix( cbind(.arv.Path.sim, as.matrix(Mktable$Path) ) )
		} else {
			.arv.Cost.sim <- as.matrix(Mktable$Cost)
			.arv.Effectiveness.sim <- as.matrix(Mktable$Effectiveness)
			.arv.Survival.sim <- as.matrix(Mktable$Survival)
			.arv.Path.sim <- as.matrix(Mktable$Path)
		}		
	}
	
	ans <- list(Path = .arv.Path.sim, 
				Cost = .arv.Cost.sim, 
				Effectiveness = .arv.Effectiveness.sim, 
				Survival = apply(.arv.Survival.sim, 1, sum, na.rm = TRUE) )
				
	# cat("===========================================\n")
	# print(.arv.Cost.sim)
	# print(.arv.Effectiveness.sim)
	# print(.arv.Survival.sim)
	# print(.arv.Path.sim)
	# cat("===========================================\n")

	return(ans)
	
}
