rcustomdistr <-
function(n, x, px, cumulative = TRUE) {
	# adicionar tratamento de erros para a funo
	if ( !cumulative ) {
		if ( sum(px) != 1 ) {
			px <- px / sum(px)
			print("WARNING : px weighted to be a density probability function! \n")
		}
		px <- cumsum(px)
	} else {
		if ( max(px) != 1.0 ) {
			px <- sort(px) / max(px)
			print("WARNING : px weighted to be a cumulative probability function! \n")
		}
	}

	ans <- array(NA,n)
	sorteados <- runif(n)
	
	# Gera pelo mtodo da inverso CDF
	invrandmcn <- function(k, px) {
		posselected <- sum(px <= k) + 1
		return(	posselected )
	}
	
	ans <- x[ mapply( invrandmcn, sorteados , MoreArgs = list(px = px)) ]
	return(ans)
}
