saw2.compute <-
function(variableselected, variableselected2, nintervals, minval, maxval, minval2, maxval2) {
	
	sarseqrange <- ( maxval - minval ) / (nintervals - 1)
	saseqvalues <- seq(minval, maxval, sarseqrange)
	
	sarseqrange2 <- ( maxval2 - minval2 ) / (nintervals - 1)
	saseqvalues2 <- seq(minval2, maxval2, sarseqrange2)
	
	labelsvalue <- array(,0)
	labelsvalue2 <- array(,0)

	for (i in saseqvalues) {
		for (j in saseqvalues2) {
			# Atualiza o valor da variavel a ser processada na sa2w (sensitivity analysis 2 way)
			assign(variableselected, i)
			assign(variableselected, i, envir = .GlobalEnv)
			assign(variableselected2, j)
			assign(variableselected2, j, envir = .GlobalEnv)
			
			TheTree <- get("TheTree", envir = .EnvironmentArvoRe)
			
			# Computa os valores das probabilidades que sao string
			TheTree$Prob <- sapply(TheTree$Prob,FUN = exec.text)
			TheTree$Payoff1 <- as.numeric(sapply(TheTree$Payoff1,FUN = exec.text))
			TheTree$Payoff2 <- as.numeric(sapply(TheTree$Payoff2,FUN = exec.text))
	
			numrep <- dim(TheTree)[1]
			
			# Gera a coluna com os valores usados na sa1w para a variavel
			labelsvalue <- c(labelsvalue, rep(i,numrep))
			labelsvalue2 <- c(labelsvalue2, rep(j,numrep))
			
			# computa as esperancas com base no valor testado
			srspt <- summary.rollback.table(TheTree)
			
			names(srspt) <- c("Level", "Node N", "Node Name", 
							"Expected Cost", "Expected Effectiveness", "Expected C-E Ratio", 
							"Father Node", "Probability",
							"Cost", "Effectiveness", "Type")
			
			if ( exists("ans") ) {
				ans <- abind(ans,srspt,along=1)
			} else {
				ans <- srspt	
			}
		}
	}
	
	ans <- data.frame(Value.Var=labelsvalue, Value.Var2=labelsvalue2, ans)
	names(ans) <- c(variableselected, variableselected2, "Level", "Node N", "Node Name", 
						"Expected Cost", "Expected Effectiveness", "Expected C-E Ratio", 
						"Father Node", "Probability",
						"Cost", "Effectiveness", "Type")
						
	# Tratamento para tipos
	ans[,6] <- as.double(as.character(ans[,6]))
	ans[,7] <- as.double(as.character(ans[,7]))
	ans[,8] <- as.double(as.character(ans[,8]))

	assign("TabelaSA2w", ans, envir = .GlobalEnv)
	
	return(ans)
}
