show.Syntax <-
function (syntax.file.array,...) {
	require(tcltk)
	
	# A janela Tk
	showSyntaxWindow  <- tktoplevel()
	title <- "arvoRe - Syntax File"
	tkwm.title(showSyntaxWindow,title)
	
	framecontens <- tkwidget(showSyntaxWindow, "labelframe", borderwidth = 0, relief = "groove")
	framebutton <- tkwidget(showSyntaxWindow, "labelframe", borderwidth = 0, relief = "groove")
	
	xscr <- tkscrollbar(framecontens, repeatinterval=5,orient="horizontal",
	                       command=function(...)tkxview(txt,...))
	yscr <- tkscrollbar(framecontens, repeatinterval=5,
	                       command=function(...)tkyview(txt,...))
	txt <- tktext(framecontens,bg="white",font="courier",
	    xscrollcommand=function(...)tkset(xscr,...),yscrollcommand=function(...)tkset(yscr,...),
	    wrap="none")
	tkgrid(txt,yscr)
	tkgrid(xscr)
	tkgrid.configure(yscr,sticky="ns")
	tkgrid.configure(xscr,sticky="ew")
	
	for (i in syntax.file.array) {
		tkinsert(txt,"end",paste(i," \n",sep=""))
	}
	
# 	tkconfigure(showSyntaxWindow, state="disabled")
	tkfocus(showSyntaxWindow)

	OnOK <- function()
	{
		if ( exists(".syntax.file.array.old", envir = .EnvironmentArvoRe) ) {
			remove(".syntax.file.array.old", envir = .EnvironmentArvoRe)
		}
		
		# rescrever para os novos padroes de prob.
		fileName <- get(".syntaxfile", envir = .EnvironmentArvoRe)
		
		syntaxcontents <- tclvalue( tkget(txt,"1.0","end") )
		
		syntaxfilecon <- file(fileName, "w")
		cat(paste(syntaxcontents," \n",sep=""),file = syntaxfilecon, append = TRUE)
		close(syntaxfilecon)
		
		syntaxfilecon <- file(fileName, "r")
		read.Syntax(syntaxfilecon)
		close(syntaxfilecon)
		unlink(fileName)
		
		tkdestroy(showSyntaxWindow)
		tkfocus(tt)
	}
	
	OK.but <-tkbutton(framebutton,text="   OK   ",command=OnOK)
	
	OnRun <- function()
	{
		fileName <- get(".syntaxfile", envir = .EnvironmentArvoRe)
		
		syntaxcontents <- tclvalue( tkget(txt,"1.0","end") )
		
		syntaxfilecon <- file(fileName, "w")
		cat(paste(syntaxcontents," \n",sep=""),file = syntaxfilecon, append = TRUE)
		close(syntaxfilecon)
		
		syntaxfilecon <- file(fileName, "r")
		read.Syntax(syntaxfilecon)
		close(syntaxfilecon)
		unlink(fileName)		
		
		syntax.file.array <- get("syntax.file.array", envir = .EnvironmentArvoRe)
		run.Syntax(syntax.file.array)
	}
	
	Run.but <-tkbutton(framebutton,text="   Run   ",command=OnRun)

	OnSave <- function()
	{
		# rescrever para os novos padroes de prob.
		fileName<-tclvalue(tkgetSaveFile(filetypes="{{ArvoRe Syntax Files} {.R}} {{All files} *}"))
		if (!nchar(fileName))
			tkfocus(showSyntaxWindow)
		else {
			ans <- substr(fileName,nchar(fileName)-1,nchar(fileName))
			if ( ans != ".R" ) fileName <- paste(fileName, ".R", sep="")
			
			syntaxcontents <- tclvalue( tkget(txt,"1.0","end") )

			syntaxfilecon <- file(fileName, "w")
			
			cat(paste(syntaxcontents," \n",sep=""),file = syntaxfilecon, append = TRUE)
			
			close(syntaxfilecon)
			
			tkfocus(showSyntaxWindow)
		}	
	}
	
	Save.but <-tkbutton(framebutton,text="  Save  ",command=OnSave)
	
	OnLoad <- function()
	{
		# rescrever para os novos padroes de prob.
		fileName <- tclvalue(tkgetOpenFile(filetypes="{{ArvoRe Syntax Files} {.R}} {{All files} *}"))
		if (!nchar(fileName))
			tkfocus(showSyntaxWindow)
		else {
			# guarda o antigo syntax.file.array para o caso de cancel
			.syntax.file.array.old <- syntax.file.array
			assign(".syntax.file.array.old", .syntax.file.array.old, .EnvironmentArvoRe)
			read.Syntax(fileName)
			syntax.file.array <- get("syntax.file.array", envir = .EnvironmentArvoRe)
			tkdelete(txt,"1.0","end")
			for (i in syntax.file.array) {
				tkinsert(txt,"end",paste(i," \n",sep=""))
			}
			tkfocus(showSyntaxWindow)
			
		}			
	}
	
	Load.but <-tkbutton(framebutton,text="  Load  ",command=OnLoad)
	

	OnCancel <- function()
	{
		if ( exists(".syntax.file.array.old", envir = .EnvironmentArvoRe) ) {
			syntax.file.array <- get(".syntax.file.array.old", envir = .EnvironmentArvoRe)
			assign("syntax.file.array", syntax.file.array, .EnvironmentArvoRe)
			remove(".syntax.file.array.old", envir = .EnvironmentArvoRe)
		}
		tkdestroy(showSyntaxWindow)
		tkfocus(tt)
	}
		
	Cancel.but <-tkbutton(framebutton,text=" Cancel ",command=OnCancel)
	tkbind(showSyntaxWindow, "<Escape>",OnCancel)
	
	tkgrid(OK.but, Cancel.but, Load.but, Save.but, Run.but, sticky = "s", padx = 5, pady = 5)
	
	tkgrid(framecontens)
	tkgrid(framebutton)
	
# 	posiciona.janela.no.mouse(showSyntaxWindow, 250, 230)

}
