simple.markov.coort.table <-
function(TheTree, trials = 10000, seed = FALSE) {
	# ajusta a semente escolhida pelo usurio
	if (seed != FALSE) {
		set.seed(seed)	
	}
		
	# statussimulationwindow.l2 <- tklabel(dialogsimulationwindow,textvariable=arvsimtrialnumber)	
	# tkgrid(statussimulationwindow.l2, columnspan = 2, sticky = "n")
		
	# Convert the tree to matrix format
	MatrixTheTree <- convert2matrix(TheTree)
# 	print(MatrixTheTree)
	x <- MatrixTheTree$x								# Structure matrix
	y <- MatrixTheTree$y								# Node name matrix
	typeMAT <- MatrixTheTree$typeMAT					# Node type matrix
	utilityMAT <- MatrixTheTree$utilityMAT				# Node Cost matrix 
	effectivenessMAT <- MatrixTheTree$effectivenessMAT	# Node effectiveness matrix
	probMAT <- MatrixTheTree$probMAT					# Node probability matrix

	num.col.x <- dim(x)[2]
	num.lin.x <- dim(x)[1]

	probMAT[,1] <- 1.0	# Agora o nodo raiz recebe prob = 1.
	typeMAT[,1] <- "D"	# Agora o nodo raiz recebe "D".
	
	# cria a tabela que comportar os individuos
# 	Coorte.Ind <- matrix(0, 1, trials)	# Matriz com cada individuo
# 	Coorte.Cost <- matrix(0, 1, trials)	# Matriz com custo de cada individuo
# 	Coorte.Effec <- matrix(0, 1, trials)	# Matriz com a efetividade de cada individuo
	
	# A simulao em si. Choose your destiny!
	
#	---- Pre segunda ordem...
#	sorteado <- runif(trials,0,1)
#	linprobs <- cumsum(apply(probMAT, 1, prod)) # observa a probabilidade de cada ramo acontecer numa runif
#	valn <- length(linprobs)
#	linprobs.Matrix <- matrix(linprobs, trials, valn, byrow = TRUE) # podemos ter problema de memria aqui!!!
#	resultado <- valn - apply(sorteado <= linprobs.Matrix, 1, sum) + 1
#	---- Fim pre segunda ordem

	sorteado <- runif(trials,0,1)
	
	linprobsnulo <- array(0,dim(probMAT)[1])
	valn <- length(linprobsnulo)
	linprobs.Matrix <- matrix(linprobsnulo, trials, valn, byrow = TRUE) # podemos ter problema de memria aqui!!!

#  	ans.dest <- destinos[resultado]	# quantos vo para cada categoria
#	ans.cost <- utilityMAT[resultado]
#	ans.effectiveness <- effectivenessMAT[resultado]
#  	ans.dest <- destinos[resultado]	# quantos vo para cada categoria
	resultado  <- array(0,trials)
	ans.cost <- array(0,trials)
	ans.effectiveness <- array(0,trials)
	
	# Gera os valores das distribuies
	if ( exists("distributionMAT", envir = .EnvironmentArvoRe) ) {
		distributionMAT <- get("distributionMAT", envir = .EnvironmentArvoRe)
		if ( length(distributionMAT$Name) > 0 ) {
			
			ndistributionMAT <- dim(distributionMAT)[1]
			distributionMAT.Names <- as.character(distributionMAT[,1])
			distributionMAT.Distribution <- as.character(distributionMAT[,3])
			distributionMAT.Parameters <- as.character(distributionMAT[,4])
			
			for ( i in 1:ndistributionMAT ) {
				commandoprocessar <- paste("assign('.distribution.Values.",distributionMAT.Names[i],"', r", distributionMAT.Distribution[i], "(trials, ", distributionMAT.Parameters[i], ") )", sep = "")
				eval(parse(text=commandoprocessar))
				commandoprocessar <- paste(".distribution.Values.",distributionMAT.Names[i]," <- r", distributionMAT.Distribution[i], "(trials, ", distributionMAT.Parameters[i], ")", sep = "")
				eval(parse(text=commandoprocessar))		
			}
		}
	}
	
	parse.distribution.expression <-
	function(exprdistr.arvore) {
		if ( exists("distributionMAT", envir = .EnvironmentArvoRe) ) {
			distributionMAT <- get("distributionMAT", envir = .EnvironmentArvoRe)
			if ( length(distributionMAT$Name) > 0 ) {
				nexprdistr.arvore <- length(exprdistr.arvore)
				ndistributionMAT <- dim(distributionMAT)[1]
				distributionMAT.Names <- as.character(distributionMAT[,1])
				distributionMAT.Distribution <- as.character(distributionMAT[,3])
				distributionMAT.Parameters <- as.character(distributionMAT[,4])
				
				for ( i in 1:ndistributionMAT ) {
					commandoprocessar <- paste(".distribution.Values.",distributionMAT.Names[i],"[", trialnumber,"]", sep = "")
					.distribution.valordtr <- eval(parse(text=commandoprocessar))
					if ( sum(str_detect(exprdistr.arvore, distributionMAT.Names[i])) > 0 ) { 
							distributionMAT.valornovo <- .distribution.valordtr
							commandoprocessar <- str_replace_all(exprdistr.arvore, distributionMAT.Names[i], distributionMAT.valornovo)
							# distributionMAT.ans[j] <- eval(parse(text=commandoprocessar)) # no vamos retornar o valor...
							exprdistr.arvore <- commandoprocessar
						}
				}
			}
		} 
		return(exprdistr.arvore)
	}

	# Restore tcl values for GUI
	arvsimulationstopflag <- get("arvsimulationstopflag", envir = .EnvironmentArvoRe)
	arvsimtrialnumber <- get("arvsimtrialnumber", envir = .EnvironmentArvoRe)
	
	# Faz o parse para computar as expresses...
	for (trialnumber in 1:trials) {
		stopifnot( tclvalue(arvsimulationstopflag) == 0) # variable used to stop simulation
		#tkset(arvsimtrialnumber, trialnumber) # Update the GUI about simulation
		tcl("set", arvsimtrialnumber, trialnumber)
		tcl("update")
		
		cprobMAT <- apply(probMAT, 1:2, function(x) parse.variable.expression(x) )
		cprobMAT <- apply(cprobMAT, 1:2, function(x) parse.distribution.expression(x) )
		cprobMAT <- apply(cprobMAT, 1:2, function(x) exec.text(x) )
		linprobs <- cumsum(apply(cprobMAT, 1, prod)) # observa a probabilidade de cada ramo acontecer numa runif	
		linprobs.Matrix[trialnumber,] <- linprobs
		
		linsprobs.Matrix.line <- matrix( linprobs.Matrix[trialnumber,],1,length(linprobs.Matrix[trialnumber,]) )
		
		resultado[trialnumber] <- valn - apply(sorteado[trialnumber] <= linsprobs.Matrix.line, 1, sum) + 1
		
		ctilityMAT <- apply(utilityMAT, 1:2, function(x) parse.variable.expression(x) )
		ctilityMAT <- apply(ctilityMAT, 1:2, function(x) parse.distribution.expression(x) )
		ctilityMAT <- apply(ctilityMAT, 1:2, function(x) exec.text(x) )
		
		ceffectivenessMAT <- apply(effectivenessMAT, 1:2, function(x) parse.variable.expression(x) )
		ceffectivenessMAT <- apply(ceffectivenessMAT, 1:2, function(x) parse.distribution.expression(x) )
		ceffectivenessMAT <- apply(ceffectivenessMAT, 1:2, function(x) exec.text(x) )
		
		# ajusta custo e efetividade: sero acumulados atravs dos nodos.
		if (num.lin.x > 1) {
			ctilityMAT <- apply(ctilityMAT, 1, sum)
			ceffectivenessMAT <- apply(ceffectivenessMAT, 1, sum)
		} else {
			ctilityMAT <- sum(ctilityMAT)
			ceffectivenessMAT <- sum(ceffectivenessMAT)
		}		
		
		ans.cost[trialnumber] <- ctilityMAT[resultado[trialnumber]]
		ans.effectiveness[trialnumber] <- ceffectivenessMAT[resultado[trialnumber]]
	}
	
	resultado <- valn - apply(sorteado <= linprobs.Matrix, 1, sum) + 1
	
#	ajusta elementos para matriz... pois com vetor no funciona
# 	utilityMAT <- matrix(utilityMAT, num.lin.x, num.col.x)
# 	effectivenessMAT <- matrix(utilityMAT, num.lin.x, num.col.x)
# 	probMAT <- matrix(utilityMAT, num.lin.x, num.col.x)

 	Coorte.Ind <- matrix(resultado, 1, trials)				# Matriz com cada individuo
	Coorte.Cost <- matrix(ans.cost, 1, trials)				# Matriz com custo de cada individuo
	Coorte.Effec <- matrix(ans.effectiveness, 1, trials)	# Matriz com a efetividade de cada individuo
	
	ans <- list(Path = Coorte.Ind, Cost = Coorte.Cost, Effectiveness = Coorte.Effec)
	return(ans)	# And return the result
}
